package jfrace;

/**
 *  A listener who wants to be informed when a {@link Hardware}
 *  has been added to (or removed from) an {@link AddressSpace}.
 *
 *  @author Franz-Josef Elmer
 */
public interface AddressSpaceListener {
    /**
     *  A <code>Hardware</code> has been added to (or removed from)
     *  an <code>AddressSpace</code>.
     *  @param event Event holding the details.
     */
    public void hardwareMoved(AddressSpaceEvent event);
}
