package jfrace;

/**
 *  Basic interface for any type of hardware.
 *
 *  @author Franz-Josef Elmer
 */
public interface Hardware {
    /**
     *  Reset the hardware. After reseting this hardware will be in a
     *  well-defined state.
     */
    public void reset();

    /**
     *  Return the number of bits of the data bus this hardware needs.
     *  This number is only for information. It tells
     *  whether the hardware is e.g. an 8-bit or 16-bit CPU.
     */
    public int getNumberOfBits();
}
