package jfrace.device;

import jfrace.Device;

/**
 *  Dummy device. Occupies one byte in the address space.
 *  Returns always 0.
 *
 *  @author Franz-Josef Elmer
 */
public class DummyDevice implements Device {
    public DummyDevice() {}

//
//  Implemention of the Device interface.
//

    public void reset() {}

    /** Return 8. */
    public int getNumberOfBits() {
        return 8;
    }

    /** Return 1. */
    public int getNumberOfUnits() {
        return 1;
    }

    /** Return 0. */
    public int getValue(int address) {
        return (int) getByte(address);
    }

    /** Does nothing. */
    public void setValue(int address, int value) {
        setByte(address, (byte) value);
    }

    /** Return 0. */
    public byte getByte(int address) {
        return 0;
    }

    /** Does nothing. */
    public void setByte(int address, byte value) {}
}
