####################################
#
# Test file for CPUTestSuite.
#
####################################

#
# CPU Definition:
# <class name> <offset in address space>
#
CPU = jfrace.cpu.MC6502 0

#
# RAM definition:
# one or several lines of the form
# RAM = <number of bits> <first address> <size> [<mode mask>]
RAM = 8 0 0x10000

####################################
#
# Test Statements:
#

#################### miscellaneous group ##############################
# BRK
PC=0xabcd; (0xabcd)==0; (0xfffe)==0xfe,0xaf; S=0x81; P=0 > 7 PC=0xaffe; P=0x10; S=0x7e; (0x17f)=0x10,0xcf,0xab
PC=0xabcd; (0xabcd)==0; (0xfffe)==0xfe,0xaf; S=0x81; P=0xff > 7 PC=0xaffe; P=0xff; S=0x7e; (0x17f)=0xff,0xcf,0xab

# JMP
PC=0xabcd; (0xabcd)==0x4c,0xaa,0xbb; A==0xff; P==0; X==0; Y==0; S==0 > 3 PC=0xbbaa
PC=0xabcd; (0xabcd)==0x4c,0xaa,0xbb; A==0; P==0xff; X==0xff; Y==0xff; S==0xff > 3 PC=0xbbaa
PC=0xabcd; (0xabcd)==0x6c,0xaa,0xbb; (0xbbaa)==0xfe,0xba > 5 PC=0xbafe
PC=0xabcd; (0xabcd)==0x6c,0xff,0xbb; (0xbbff)==0xfe; (0xbb00)==0xba > 5 PC=0xbafe

# JSR
PC=0xabcd; (0xabcd)==0x20,0xaa,0xbb; A==0xff; P==0; X==0; Y==0; S=0xff > 6 PC=0xbbaa; (0x1fe)=0xcf,0xab; S=0xfd
PC=0xabcd; (0xabcd)==0x20,0xaa,0xbb; A==0; P==0xff; X==0xff; Y==0xff; S=0xff > 6 PC=0xbbaa; (0x1fe)=0xcf,0xab; S=0xfd

# NOP
PC=0xabcd; (0xabcd)==0xea; A==0xff; P==0; X==0; Y==0; S==0 > 2 PC=0xabce
PC=0xabcd; (0xabcd)==0xea; A==0; P==0xff; X==0xff; Y==0xff; S==0xff > 2 PC=0xabce

# STA zero page
PC=0xabcd; (0xabcd)==0x85,0xfe; A==0xce; P==0; X==0xff; Y==0; S==0 > 3 PC=0xabcf; (0xfe)=0xce
PC=0xabcd; (0xabcd)==0x85,0xfe; A==0xce; P==0xff; X==0; Y==0xff; S==0xff > 3 PC=0xabcf; (0xfe)=0xce

# STA zero page X
PC=0xabcd; (0xabcd)==0x95,0xee; A==0xce; P==0; X==0x10; Y==0; S==0 > 4 PC=0xabcf; (0xfe)=0xce
PC=0xabcd; (0xabcd)==0x95,0xee; A==0xce; P==0xff; X==0x10; Y==0xff; S==0xff > 4 PC=0xabcf; (0xfe)=0xce

# STA absolute
PC=0xabcd; (0xabcd)==0x8d,0xfe,0xdd; A==0xce; P==0; X==0xff; Y==0; S==0 > 4 PC=0xabd0; (0xddfe)=0xce
PC=0xabcd; (0xabcd)==0x8d,0xfe,0x55; A==0xce; P==0xff; X==0; Y==0xff; S==0xff > 4 PC=0xabd0; (0x55fe)=0xce

# STA absolute X
PC=0xabcd; (0xabcd)==0x9d,0xed,0xdd; A==0xce; P==0; X==0x11; Y==0; S==0 > 5 PC=0xabd0; (0xddfe)=0xce
PC=0xabcd; (0xabcd)==0x9d,0xed,0x55; A==0xce; P==0xff; X==17; Y==0xff; S==0xff > 5 PC=0xabd0; (0x55fe)=0xce

# STA absolute Y
PC=0xabcd; (0xabcd)==0x99,0xed,0xdd; A==0xce; P==0; Y==0x11; X==0; S==0 > 5 PC=0xabd0; (0xddfe)=0xce
PC=0xabcd; (0xabcd)==0x99,0xed,0x55; A==0xce; P==0xff; Y==17; X==0xff; S==0xff > 5 PC=0xabd0; (0x55fe)=0xce

# STA indirect X
PC=0xabcd; (0xabcd)==0x81,0xba; (0xcb)==0xa0,0xb0; A==0xce; P==0; X==0x11; Y==0; S==0 > 6 PC=0xabcf; (0xb0a0)=0xce
PC=0xabcd; (0xabcd)==0x81,0xba; (0xcb)==0xa0,0xb0; A==0xce; P==0xff; X==0x11; Y==0xff; S==0xff > 6 PC=0xabcf; (0xb0a0)=0xce

# STA indirect Y
PC=0xabcd; (0xabcd)==0x91,0xba; (0xba)==0xa0,0xb0; A==0xce; P==0; Y==0x11; X==0; S==0 > 6 PC=0xabcf; (0xb0b1)=0xce
PC=0xabcd; (0xabcd)==0x91,0xba; (0xba)==0xa0,0xb0; A==0xce; P==0xff; Y==0x11; X==0xff; S==0xff > 6 PC=0xabcf; (0xb0b1)=0xce

#################### arithmetic group ##############################
# ADC immediate
PC=900; (900)==0x69,12; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=21; P=0; PC=902
PC=900; (900)==0x69,12; P=0xf6; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=21; P=0x34; PC=902
PC=900; (900)==0x69,12; P=1; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=22; P=0; PC=902
PC=900; (900)==0x69,9; P=0; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=3; PC=902
PC=900; (900)==0x69,0xf7; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=3; PC=902
PC=900; (900)==0x69,0xf7; P=1; A=8; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=3; PC=902
PC=900; (900)==0x69,99; P=0; A=33; X==0x99; Y==0xef; S==0x33 > 2 A=132; P=0xc0; PC=902
PC=900; (900)==0x69,0xf0; P=0; A=0xa0; X==0x99; Y==0xef; S==0x33 > 2 A=0x90; P=0x81; PC=902
PC=900; (900)==0x69,0xb0; P=0; A=0xa0; X==0x99; Y==0xef; S==0x33 > 2 A=0x50; P=0x41; PC=902
PC=900; (900)==0x69,0x40; P=0; A=0x80; X==0x99; Y==0xef; S==0x33 > 2 A=0xc0; P=0x80; PC=902
PC=900; (900)==0x69,0x23; P=8; A=0x45; X==0x99; Y==0xef; S==0x33 > 2 A=0x68; P=8; PC=902
PC=900; (900)==0x69,0x23; P=0xff; A=0x45; X==0x99; Y==0xef; S==0x33 > 2 A=0x69; P=0xfe; PC=902
PC=900; (900)==0x69,0x25; P=8; A=0x45; X==0x99; Y==0xef; S==0x33 > 2 A=0x70; P=8; PC=902
PC=900; (900)==0x69,0x99; P=8; A=0x45; X==0x99; Y==0xef; S==0x33 > 2 A=0x44; P=9; PC=902

# ADC zero page
PC=900; (900)==0x65,7; (7)==17; A=4; X==77; Y==6; S==33 > 3 A=21; PC=902
PC=900; (900)==0x65,9; (9)==7; A=0xf9; X==77; Y==6; S==33 > 3 A=0; P=3; PC=902
PC=900; (900)==0x65,130; (130)==0xf9; A=7; X==77; Y==6; S==33 > 3 A=0; P=3; PC=902

# ADC zero page indexed X
PC=900; (900)==0x75,7; (14)==17; A=4; X==7; Y==6; S==33 > 4 A=21; PC=902
PC=900; (900)==0x75,9; (146)==7; A=0xf9; X==137; Y==6; S==33 > 4 A=0; P=3; PC=902
PC=900; (900)==0x75,130; (137)==0xf9; A=7; X==7; Y==6; S==33 > 4 A=0; P=3; PC=902

# ADC absolute
PC=900; (900)==0x6d,7,10; (0xa07)==17; A=4; X==7; Y==6; S==33 > 4 A=21; PC=903
PC=900; (900)==0x6d,9,1; (0x109)==7; A=0xf9; X==137; Y==6; S==33 > 4 A=0; P=3; PC=903
PC=900; (900)==0x6d,0xab,0xcd; (0xcdab)==0xf9; A=7; X==7; Y==6; S==33 > 4 A=0; P=3; PC=903

# ADC absolute indexed X
PC=900; (900)==0x7d,7,10; (0xa0e)==17; A=4; X==7; Y==6; S==33 > 4 A=21; PC=903
PC=900; (900)==0x7d,2,1; (0x19b)==7; A=0xf9; X==0x99; Y==6; S==33 > 4 A=0; P=3; PC=903
PC=900; (900)==0x7d,0xab,0xcd; (0xcdb2)==0xf9; A=7; X==7; Y==6; S==33 > 4 A=0; P=3; PC=903

# ADC absolute indexed Y
PC=900; (900)==0x79,7,10; (0xa0e)==17; A=4; Y==7; X==6; S==33 > 4 A=21; PC=903
PC=900; (900)==0x79,2,1; (0x19b)==7; A=0xf9; Y==0x99; X==6; S==33 > 4 A=0; P=3; PC=903
PC=900; (900)==0x79,0xab,0xcd; (0xcdb2)==0xf9; A=7; Y==7; X==6; S==33 > 4 A=0; P=3; PC=903

# ADC indexed indirect X
PC=900; (900)==0x61,7; (14)==117; (117)==17; A=4; X==7; Y==6; S==33 > 6 A=21; PC=902
PC=900; (900)==0x61,9; (146)==0x88,0x99; (0x9988)==7; A=0xf9; X==137; Y==6; S==33 > 6 A=0; P=3; PC=902
PC=900; (900)==0x61,130; (137)==2; (2)==0xf9; A=7; X==7; Y==6; S==33 > 6 A=0; P=3; PC=902

# ADC indirect indexed Y
PC=900; (900)==0x71,7; (7)==117; (123)==17; A=4; X==7; Y==6; S==33 > 5 A=21; PC=902
PC=900; (900)==0x71,9; (9)==0x88,0x99; (0x998e)==7; A=0xf9; X==137; Y==6; S==33 > 5 A=0; P=3; PC=902
PC=900; (900)==0x71,130; (130)==2; (0x98)==0xf9; A=7; X==7; Y==0x96; S==33 > 5 A=0; P=3; PC=902

#########
# AND immediate
PC=900; (900)==0x29,12; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=8; P=0; PC=902
PC=900; (900)==0x29,12; P=0xff; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=8; P=0x7d; PC=902
PC=900; (900)==0x29,8; P=0; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0x29,8; P=0xff; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=0x7f; PC=902
PC=900; (900)==0x29,0x90; P=0; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0x90; P=0x80; PC=902
PC=900; (900)==0x29,0x90; P=0xff; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0x90; P=0xfd; PC=902

#########
# BIT zero page
PC=900; (900)==0x24,7; (7)==12; P=0; A==9; X==0x99; Y==0xef; S==0x33 > 3 P=0; PC=902
PC=900; (900)==0x24,7; (7)==12; P=0xff; A==9; X==0x99; Y==0xef; S==0x33 > 3 P=0x7d; PC=902
PC=900; (900)==0x24,7; (7)==8; P=0; A==1; X==0x99; Y==0xef; S==0x33 > 3 P=2; PC=902
PC=900; (900)==0x24,7; (7)==8; P=0xff; A==1; X==0x99; Y==0xef; S==0x33 > 3 P=0x7f; PC=902
PC=900; (900)==0x24,7; (7)==0x90; P=0; A==0xf7; X==0x99; Y==0xef; S==0x33 > 3 P=0x80; PC=902
PC=900; (900)==0x24,7; (7)==0x90; P=0xff; A==0xf7; X==0x99; Y==0xef; S==0x33 > 3 P=0xfd; PC=902

#########
# CMP immediate
PC=900; (900)==0xc9,12; P=0; A==9; X==0x99; Y==0xef; S==0x33 > 2 P=0x81; PC=902
PC=900; (900)==0xc9,12; P=0xff; A==9; X==0x99; Y==0xef; S==0x33 > 2 P=0xfd; PC=902
PC=900; (900)==0xc9,12; P=0; A==12; X==0x99; Y==0xef; S==0x33 > 2 P=2; PC=902
PC=900; (900)==0xc9,12; P=0; A==19; X==0x99; Y==0xef; S==0x33 > 2 P=0; PC=902
PC=900; (900)==0xc9,129; P=0; A==133; X==0x99; Y==0xef; S==0x33 > 2 P=0; PC=902
PC=900; (900)==0xc9,129; P=0xff; A==133; X==0x99; Y==0xef; S==0x33 > 2 P=0x7c; PC=902

#########
# CPX immediate
PC=900; (900)==0xe0,12; P=0; X==9; Y==0xef; S==0x33 > 2 P=0x81; PC=902
PC=900; (900)==0xe0,129; P=0xff; X==133; A==0x99; Y==0xef; S==0x33 > 2 P=0x7c; PC=902

#########
# CPY immediate
PC=900; (900)==0xc0,12; P=0; Y==9; A==0xef; S==0x33 > 2 P=0x81; PC=902
PC=900; (900)==0xc0,129; P=0xff; Y==133; A==0x99; X==0xef; S==0x33 > 2 P=0x7c; PC=902

#########
# EOR immediate
PC=900; (900)==0x49,0xf2; P=0; A=0xc9; X==0x99; Y==0xef; S==0x33 > 2 A=0x3b; P=0; PC=902
PC=900; (900)==0x49,12; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=5; P=0; PC=902
PC=900; (900)==0x49,12; P=0xff; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=5; P=0x7d; PC=902
PC=900; (900)==0x49,8; P=0; A=8; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0x49,8; P=0xff; A=8; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=0x7f; PC=902
PC=900; (900)==0x49,0x90; P=0; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0x91; P=0x80; PC=902
PC=900; (900)==0x49,0x90; P=0xff; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0x91; P=0xfd; PC=902

#########
# LDA immediate
PC=900; (900)==0xA9,12; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=12; P=0; PC=902
PC=900; (900)==0xA9,12; P=0xff; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=12; P=0x7d; PC=902
PC=900; (900)==0xA9,0; P=0; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0xA9,0; P=0xff; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=0x7f; PC=902
PC=900; (900)==0xA9,0x90; P=0; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0x90; P=0x80; PC=902
PC=900; (900)==0xA9,0x90; P=0xff; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0x90; P=0xfd; PC=902

#########
# ORA immediate
PC=900; (900)==0x09,12; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=13; P=0; PC=902
PC=900; (900)==0x09,12; P=0xff; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=13; P=0x7d; PC=902
PC=900; (900)==0x09,0; P=0; A=0; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0x09,0; P=0xff; A=0; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=0x7f; PC=902
PC=900; (900)==0x09,0x90; P=0; A=0xf5; X==0x99; Y==0xef; S==0x33 > 2 A=0xf5; P=0x80; PC=902
PC=900; (900)==0x09,0x90; P=0xff; A=1; X==0x99; Y==0xef; S==0x33 > 2 A=0x91; P=0xfd; PC=902

#########
# SBC immediate
PC=900; (900)==0xE9,9; P=0; A=12; X==0x99; Y==0xef; S==0x33 > 2 A=3; P=0; PC=902
PC=900; (900)==0xE9,9; P=0xf7; A=12; X==0x99; Y==0xef; S==0x33 > 2 A=2; P=0x34; PC=902
PC=900; (900)==0xe9,9; P=0; A=9; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0xe9,0xf7; P=0; A=0xf7; X==0x99; Y==0xef; S==0x33 > 2 A=0; P=2; PC=902
PC=900; (900)==0xe9,0x23; P=8; A=0x57; X==0x99; Y==0xef; S==0x33 > 2 A=0x34; P=8; PC=902
PC=900; (900)==0xe9,0x23; P=8; A=0x51; X==0x99; Y==0xef; S==0x28 > 2 A=0x28; P=8; PC=902
PC=900; (900)==0xe9,0x23; P=0xff; A=0x51; X==0x99; Y==0xef; S==0x28 > 2 A=0x27; P=0xfe; PC=902
PC=900; (900)==0xe9,0x63; P=8; A=0x51; X==0x99; Y==0xef; S==0x28 > 2 A=0x88; P=9; PC=902

#################### shift group ##############################
# ASL Accumulator
PC=0xabcd; (0xabcd)==0xa; P=0; A=3; X==0; Y==0xaa; S==0 > 2 A=6; P=0; PC=0xabce
PC=0xabcd; (0xabcd)==0xa; P=0xff; A=3; X==0xff; Y==0x55; S==0xff > 2 A=6; P=0x7c; PC=0xabce
PC=0xabcd; (0xabcd)==0xa; P=0; A=0x80; X==0; Y==0xaa; S==0 > 2 A=0; P=3; PC=0xabce
PC=0xabcd; (0xabcd)==0xa; P=0; A==0; X==0; Y==0xaa; S==0 > 2 P=2; PC=0xabce
PC=0xabcd; (0xabcd)==0xa; P=0; A=0x70; X==0; Y==0xaa; S==0 > 2 A=0xe0; P=0x80; PC=0xabce

# ASL zero page
PC=0xabcd; (0xabcd)==6,0xff; (0xff)=3; P=0; A==0x55; X==0; Y==0xaa; S==0 > 5 (0xff)=6; P=0; PC=0xabcf
PC=0xabcd; (0xabcd)==6,0xff; (0xff)=3; P=0xff; A==0xaa; X==0xff; Y==0x55; S==0xff > 5 (0xff)=6; P=0x7c; PC=0xabcf

# ASL zero page X
PC=0xabcd; (0xabcd)==0x16,0xf0; (0xff)=3; P=0; A==0x55; X==15; Y==0xaa; S==0 > 6 (0xff)=6; P=0; PC=0xabcf
PC=0xabcd; (0xabcd)==0x16,0xf0; (0xff)=3; P=0xff; A==0xaa; X==15; Y==0x55; S==0xff > 6 (0xff)=6; P=0x7c; PC=0xabcf

# ASL absolute
PC=0xabcd; (0xabcd)==14,0xff,0xcc; (0xccff)=3; P=0; A==0x55; X==0; Y==0xaa; S==0 > 6 (0xccff)=6; P=0; PC=0xabd0
PC=0xabcd; (0xabcd)==14,0xff,0xcc; (0xccff)=3; P=0xff; A==0xaa; X==0xff; Y==0x55; S==0xff > 6 (0xccff)=6; P=0x7c; PC=0xabd0

# ASL absolute X
PC=0xabcd; (0xabcd)==0x1e,0xf0,0xcc; (0xccff)=3; P=0; A==0x55; X==15; Y==0xaa; S==0 > 7 (0xccff)=6; P=0; PC=0xabd0
PC=0xabcd; (0xabcd)==0x1e,0xf0,0xcc; (0xccff)=3; P=0xff; A==0xaa; X==15; Y==0x55; S==0xff > 7 (0xccff)=6; P=0x7c; PC=0xabd0

# LSR Accumulator
PC=0xabcd; (0xabcd)==0x4a; P=0; A=6; X==0; Y==0xaa; S==0 > 2 A=3; P=0; PC=0xabce
PC=0xabcd; (0xabcd)==0x4a; P=0xff; A=6; X==0xff; Y==0x55; S==0xff > 2 A=3; P=0x7c; PC=0xabce
PC=0xabcd; (0xabcd)==0x4a; P=0; A=1; X==0; Y==0xaa; S==0 > 2 A=0; P=3; PC=0xabce
PC=0xabcd; (0xabcd)==0x4a; P=0; A==0; X==0; Y==0xaa; S==0 > 2 P=2; PC=0xabce

# LSR zero page
PC=0xabcd; (0xabcd)==0x46,0xff; (0xff)=6; P=0; A==0x55; X==0; Y==0xaa; S==0 > 5 (0xff)=3; P=0; PC=0xabcf
PC=0xabcd; (0xabcd)==0x46,0xff; (0xff)=6; P=0xff; A==0xaa; X==0xff; Y==0x55; S==0xff > 5 (0xff)=3; P=0x7c; PC=0xabcf

# LSR zero page X
PC=0xabcd; (0xabcd)==0x56,0xf0; (0xff)=6; P=0; A==0x55; X==15; Y==0xaa; S==0 > 6 (0xff)=3; P=0; PC=0xabcf
PC=0xabcd; (0xabcd)==0x56,0xf0; (0xff)=6; P=0xff; A==0xaa; X==15; Y==0x55; S==0xff > 6 (0xff)=3; P=0x7c; PC=0xabcf

# LSR absolute
PC=0xabcd; (0xabcd)==0x4e,0xff,0xcc; (0xccff)=6; P=0; A==0x55; X==0; Y==0xaa; S==0 > 6 (0xccff)=3; P=0; PC=0xabd0
PC=0xabcd; (0xabcd)==0x4e,0xff,0xcc; (0xccff)=6; P=0xff; A==0xaa; X==0xff; Y==0x55; S==0xff > 6 (0xccff)=3; P=0x7c; PC=0xabd0

# LSR absolute X
PC=0xabcd; (0xabcd)==0x5e,0xf0,0xcc; (0xccff)=6; P=0; A==0x55; X==15; Y==0xaa; S==0 > 7 (0xccff)=3; P=0; PC=0xabd0
PC=0xabcd; (0xabcd)==0x5e,0xf0,0xcc; (0xccff)=6; P=0xff; A==0xaa; X==15; Y==0x55; S==0xff > 7 (0xccff)=3; P=0x7c; PC=0xabd0

# ROL Accumulator
PC=0xabcd; (0xabcd)==0x2a; A=3; P==0 > 2 A=6; PC=0xabce
PC=0xabcd; (0xabcd)==0x2a; A=3; P=1 > 2 A=7; P=0; PC=0xabce
PC=0xabcd; (0xabcd)==0x2a; A=0x70; P=1 > 2 A=0xe1; P=0x80; PC=0xabce
PC=0xabcd; (0xabcd)==0x2a; A=0x80; P=1 > 2 A=1; P=1; PC=0xabce
PC=0xabcd; (0xabcd)==0x2a; A=0x80 > 2 A=0; P=3; PC=0xabce
PC=0xabcd; (0xabcd)==0x2a; A=0xc0; P=1 > 2 A=0x81; P=0x81; PC=0xabce

# ROL zeropage
PC=0xabcd; (0xabcd)==0x26,0xff; P=1 > 5 (0xff)=1; P=0; PC=0xabcf

# ROL absolute
PC=0xabcd; (0xabcd)==0x2e,0xff,0xaa; P=1 > 6 (0xaaff)=1; P=0; PC=0xabd0

# ROL zeropage X
PC=0xabcd; (0xabcd)==0x36,0xf0; P=1; X==15 > 6 (0xff)=1; P=0; PC=0xabcf

# ROL absolute X
PC=0xabcd; (0xabcd)==0x3e,0xf0,0xaa; P=1; X==15 > 7 (0xaaff)=1; P=0; PC=0xabd0

# ROR Accumulator
PC=0xabcd; (0xabcd)==0x6a; P=1 > 2 A=0x80; P=0x80; PC=0xabce
PC=0xabcd; (0xabcd)==0x6a; A=1; P=1 > 2 A=0x80; P=0x81; PC=0xabce
PC=0xabcd; (0xabcd)==0x6a; A=1 > 2 A=0; P=3; PC=0xabce
PC=0xabcd; (0xabcd)==0x6a; A=0xaa > 2 A=0x55; PC=0xabce

# ROR zeropage
PC=0xabcd; (0xabcd)==0x66,0xff; P=1 > 5 (0xff)=0x80; P=0x80; PC=0xabcf

# ROR absolute
PC=0xabcd; (0xabcd)==0x6e,0xff,0xaa; P=1 > 6 (0xaaff)=0x80; P=0x80; PC=0xabd0

# ROR zeropage X
PC=0xabcd; (0xabcd)==0x76,0xf0; P=1; X==15 > 6 (0xff)=0x80; P=0x80; PC=0xabcf

# ROR absolute X
PC=0xabcd; (0xabcd)==0x7e,0xf0,0xaa; P=1; X==15 > 7 (0xaaff)=0x80; P=0x80; PC=0xabd0

#################### branch group ##############################
# BCC
PC=0xabce; (0xabce)==0x90,3 > 3 PC=0xabd3
PC=0xabce; (0xabce)==0x90,3; P==1 > 2 PC=0xabd0
PC=0xabce; (0xabce)==0x90,0xf0; A==0xff; X==0xff; Y==0xff; S==0xff > 3 PC=0xabc0
PC=0xabce; (0xabce)==0x90,0xf0; P==1; A==0xff; X==0xff; Y==0xff; S==0xff > 2 PC=0xabd0

# BCS
PC=0xabce; (0xabce)==0xb0,3 > 2 PC=0xabd0
PC=0xabce; (0xabce)==0xb0,3; P==1 > 3 PC=0xabd3
PC=0xabce; (0xabce)==0xb0,0xf0; A==0xff; X==0xff; Y==0xff; S==0xff > 2 PC=0xabd0
PC=0xabce; (0xabce)==0xb0,0xf0; P==1; A==0xff; X==0xff; Y==0xff; S==0xff > 3 PC=0xabc0

# BNE
PC=0xabce; (0xabce)==0xd0,3 > 3 PC=0xabd3
PC=0xabce; (0xabce)==0xd0,3; P==2 > 2 PC=0xabd0

# BEQ
PC=0xabce; (0xabce)==0xf0,3 > 2 PC=0xabd0
PC=0xabce; (0xabce)==0xf0,3; P==2 > 3 PC=0xabd3

# BVC
PC=0xabce; (0xabce)==0x50,3 > 3 PC=0xabd3
PC=0xabce; (0xabce)==0x50,3; P==0x40 > 2 PC=0xabd0

# BVS
PC=0xabce; (0xabce)==0x70,3 > 2 PC=0xabd0
PC=0xabce; (0xabce)==0x70,3; P==0x40 > 3 PC=0xabd3

# BPL
PC=0xabce; (0xabce)==0x10,3 > 3 PC=0xabd3
PC=0xabce; (0xabce)==0x10,3; P==0x80 > 2 PC=0xabd0

# BMI
PC=0xabce; (0xabce)==0x30,3 > 2 PC=0xabd0
PC=0xabce; (0xabce)==0x30,3; P==0x80 > 3 PC=0xabd3

#################### clear set group ##############################
# CLC
PC=0xabcd; (0xabcd)==0x18 > 2 PC=0xabce
PC=0xabcd; (0xabcd)==0x18; P=0xff > 2 P=0xfe; PC=0xabce

# SEC
PC=0xabcd; (0xabcd)==0x38 > 2 P=1; PC=0xabce
PC=0xabcd; (0xabcd)==0x38; P==0xff > 2 PC=0xabce

# CLI
PC=0xabcd; (0xabcd)==0x58 > 2 PC=0xabce
PC=0xabcd; (0xabcd)==0x58; P=0xff > 2 P=0xfb; PC=0xabce

# SEI
PC=0xabcd; (0xabcd)==0x78 > 2 P=4; PC=0xabce
PC=0xabcd; (0xabcd)==0x78; P==0xff > 2 PC=0xabce

# CLD
PC=0xabcd; (0xabcd)==0xd8 > 2 PC=0xabce
PC=0xabcd; (0xabcd)==0xd8; P=0xff > 2 P=0xf7; PC=0xabce

# SED
PC=0xabcd; (0xabcd)==0xf8 > 2 P=8; PC=0xabce
PC=0xabcd; (0xabcd)==0xf8; P==0xff > 2 PC=0xabce

# CLV
PC=0xabcd; (0xabcd)==0xb8 > 2 PC=0xabce
PC=0xabcd; (0xabcd)==0xb8; P=0xff > 2 P=0xbf; PC=0xabce

#################### CPX CPY group ##############################
#########
# CPX immediate
PC=900; (900)==0xe0,12; P=0; X==9; Y==0xef; S==0x33 > 2 P=0x81; PC=902
PC=900; (900)==0xe0,129; P=0xff; X==133; A==0x99; Y==0xef; S==0x33 > 2 P=0x7c; PC=902

# CPX zero page
PC=900; (900)==0xe4,7; (7)==12; P=0; X==9; Y==0xef; S==0x33 > 3 P=0x81; PC=902
PC=900; (900)==0xe4,7; (7)==129; P=0xff; X==133; A==0x99; Y==0xef; S==0x33 > 3 P=0x7c; PC=902

# CPX absolute
PC=900; (900)==0xec,7,3; (0x307)==12; P=0; X==9; Y==0xef; S==0x33 > 4 P=0x81; PC=903
PC=900; (900)==0xec,7,3; (0x307)==129; P=0xff; X==133; A==0x99; Y==0xef; S==0x33 > 4 P=0x7c; PC=903

#########
# CPY immediate
PC=900; (900)==0xc0,12; P=0; Y==9; A==0xef; S==0x33 > 2 P=0x81; PC=902
PC=900; (900)==0xc0,129; P=0xff; Y==133; A==0x99; X==0xef; S==0x33 > 2 P=0x7c; PC=902

# CPY zero page
PC=900; (900)==0xc4,7; (7)==12; P=0; Y==9; A==0xef; S==0x33 > 3 P=0x81; PC=902
PC=900; (900)==0xc4,7; (7)==129; P=0xff; Y==133; A==0x99; X==0xef; S==0x33 > 3 P=0x7c; PC=902

# CPY absolute
PC=900; (900)==0xcc,7,9; (0x907)==12; P=0; Y==9; A==0xef; S==0x33 > 4 P=0x81; PC=903
PC=900; (900)==0xcc,7,9; (0x907)==129; P=0xff; Y==133; A==0x99; X==0xef; S==0x33 > 4 P=0x7c; PC=903

#################### Inc Dec group ##############################
#########
# INC zero page
PC=0xabcd; (0xabcd)==0xe6,0xff; (0xff)=7 > 5 (0xff)=8; PC=0xabcf
PC=0xabcd; (0xabcd)==0xe6,0xff; (0xff)=7; P=0xff; A==0xff; X==0xff; Y==0xff > 5 (0xff)=8; P=0x7d; PC=0xabcf
PC=0xabcd; (0xabcd)==0xe6,0xff; (0xff)=0x7f > 5 (0xff)=0x80; P=0x80; PC=0xabcf
PC=0xabcd; (0xabcd)==0xe6,0xff; (0xff)=0xff > 5 (0xff)=0; P=2; PC=0xabcf

# INC absolute
PC=0xabcd; (0xabcd)==0xee,0xff,9; (0x9ff)=0xff > 6 (0x9ff)=0; P=2; PC=0xabd0

# INC zero page X
PC=0xabcd; (0xabcd)==0xf6,0xf0; (0xff)=0xff; X==15 > 6 (0xff)=0; P=2; PC=0xabcf

# INC absolute X
PC=0xabcd; (0xabcd)==0xfe,0xf0,9; (0x9ff)=0xff; X==15 > 7 (0x9ff)=0; P=2; PC=0xabd0

#########
# INX
PC=0xabcd; (0xabcd)==0xe8; X=0xff; Y==55; A==77; S==99 > 2 X=0; P=2; PC=0xabce

#########
# INY
PC=0xabcd; (0xabcd)==0xc8; Y=0xff; X==55; A==77; S==99 > 2 Y=0; P=2; PC=0xabce

#########
# DEC zero page
PC=0xabcd; (0xabcd)==0xc6,0xff; (0xff)=7 > 5 (0xff)=6; PC=0xabcf
PC=0xabcd; (0xabcd)==0xc6,0xff; (0xff)=7; P=0xff; A==0xff; X==0xff; Y==0xff > 5 (0xff)=6; P=0x7d; PC=0xabcf
PC=0xabcd; (0xabcd)==0xc6,0xff; (0xff)=0 > 5 (0xff)=0xff; P=0x80; PC=0xabcf
PC=0xabcd; (0xabcd)==0xc6,0xff; (0xff)=1 > 5 (0xff)=0; P=2; PC=0xabcf

# DEC absolute
PC=0xabcd; (0xabcd)==0xce,0xff,9; (0x9ff)=1 > 6 (0x9ff)=0; P=2; PC=0xabd0

# DEC zero page X
PC=0xabcd; (0xabcd)==0xd6,0xf0; (0xff)=1; X==15 > 6 (0xff)=0; P=2; PC=0xabcf

# DEC absolute X
PC=0xabcd; (0xabcd)==0xde,0xf0,9; (0x9ff)=1; X==15 > 7 (0x9ff)=0; P=2; PC=0xabd0

#########
# DEX
PC=0xabcd; (0xabcd)==0xCA; X=1; Y==55; A==77; S==99 > 2 X=0; P=2; PC=0xabce

#########
# DEY
PC=0xabcd; (0xabcd)==0x88; Y=1; X==55; A==77; S==99 > 2 Y=0; P=2; PC=0xabce

#################### Load Store XY Dec group ##############################
#########
# LDX immediate
PC=0xabcd; (0xabcd)==0xa2,99; Y==0; A==0; S==0 > 2 X=99; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa2,0; X=0xff; Y==0; A==0; S==0 > 2 X=0; P=2; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa2,0xaf; X=0xff; Y==0xff; A==0xff; S==0xff > 2 X=0xaf; P=0x80; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa2,99; P=0xff; Y==0; A==0; S==0 > 2 X=99; P=0x7d; PC=0xabcf

# LDX zero page
PC=0xabcd; (0xabcd)==0xa6,9; (9)==99; Y==0; A==0; S==0 > 3 X=99; PC=0xabcf

# LDX absolute
PC=0xabcd; (0xabcd)==0xae,9,11; (0xb09)==99; Y==0; A==0; S==0 > 4 X=99; PC=0xabd0

# LDX zero page Y
PC=0xabcd; (0xabcd)==0xb6,2; (9)==99; Y==7; A==0; S==0 > 4 X=99; PC=0xabcf

# LDX absolute Y
PC=0xabcd; (0xabcd)==0xbe,2,11; (0xb09)==99; Y==7; A==0; S==0 > 4 X=99; PC=0xabd0

#########
# LDY immediate
PC=0xabcd; (0xabcd)==0xa0,99; X==0; A==0; S==0 > 2 Y=99; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa0,0; Y=0xff; X==0; A==0; S==0 > 2 Y=0; P=2; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa0,0xaf; Y=0xff; X==0xff; A==0xff; S==0xff > 2 Y=0xaf; P=0x80; PC=0xabcf
PC=0xabcd; (0xabcd)==0xa0,99; P=0xff; X==0; A==0; S==0 > 2 Y=99; P=0x7d; PC=0xabcf

# LDY zero page
PC=0xabcd; (0xabcd)==0xa4,9; (9)==99; X==0; A==0; S==0 > 3 Y=99; PC=0xabcf

# LDY absolute
PC=0xabcd; (0xabcd)==0xac,9,11; (0xb09)==99; X==0; A==0; S==0 > 4 Y=99; PC=0xabd0

# LDY zero page X
PC=0xabcd; (0xabcd)==0xb4,2; (9)==99; X==7; A==0; S==0 > 4 Y=99; PC=0xabcf

# LDY absolute X
PC=0xabcd; (0xabcd)==0xbc,2,11; (0xb09)==99; X==7; A==0; S==0 > 4 Y=99; PC=0xabd0

#########
# STX zero page
PC=0xabcd; (0xabcd)==0x86,9; X==78; Y==0xff; A==0; S==0 > 3 (9)=78; PC=0xabcf
PC=0xabcd; (0xabcd)==0x86,9; X==0xff; P==0xff; Y==0xff; A==0; S==0 > 3 (9)=0xff; PC=0xabcf

# STX absolute
PC=0xabcd; (0xabcd)==0x8e,9,0xae; X==78; Y==0xff; A==0; S==0 > 4 (0xae09)=78; PC=0xabd0

# STX zero page Y
PC=0xabcd; (0xabcd)==0x96,9; X==78; Y==6; A==0; S==0 > 4 (15)=78; PC=0xabcf

#########
# STY zero page
PC=0xabcd; (0xabcd)==0x84,9; Y==78; X==0xff; A==0; S==0 > 3 (9)=78; PC=0xabcf
PC=0xabcd; (0xabcd)==0x84,9; Y==0xff; P==0xff; X==0xff; A==0; S==0 > 3 (9)=0xff; PC=0xabcf

# STY absolute
PC=0xabcd; (0xabcd)==0x8c,9,0xae; Y==78; X==0xff; A==0; S==0 > 4 (0xae09)=78; PC=0xabd0

# STY zero page X
PC=0xabcd; (0xabcd)==0x94,9; Y==78; X==6; A==0; S==0 > 4 (15)=78; PC=0xabcf

#################### Push Pull group ##############################
# PHA
PC=0xabcd; (0xabcd)==0x48; A==0x55; S=0xff > 3 (0x1ff)=0x55; S=0xfe; PC=0xabce
PC=0xabcd; (0xabcd)==0x48; A==0xaa; S=0xff; P==0xff; X==0xff; Y==0xff > 3 (0x1ff)=0xaa; S=0xfe; PC=0xabce

# PHP
PC=0xabcd; (0xabcd)==8; P==0x55; A==0xff; S=7 > 3 (0x107)=0x55; S=6; PC=0xabce
PC=0xabcd; (0xabcd)==8; P==0xaa; A==9; X==0xff; Y==0xff; S=7 > 3 (0x107)=0xaa; S=6; PC=0xabce

# PLA
PC=0xabcd; (0xabcd)==0x68; (0x108)==0x55; A=0xff; S=7 > 4 A=0x55; S=8; PC=0xabce
PC=0xabcd; (0xabcd)==0x68; (0x108)==0xaa; X==0xff; Y==0xff; P==0xff; S=7 > 4 A=0xaa; S=8; PC=0xabce

# PLP
PC=0xabcd; (0xabcd)==0x28; (0x108)==0x55; P=0xff; S=7 > 4 P=0x55; S=8; PC=0xabce
PC=0xabcd; (0xabcd)==0x28; (0x108)==0xaa; X==0xff; Y==0xff; A==0xff; S=7 > 4 P=0xaa; S=8; PC=0xabce

#################### Return group ##############################
# RTI
PC=0xabcd; (0xabcd)==0x40; (0x1fd)==0xaa,0xfe,0xaf; S=0xfc > 6 P=0xaa; S=0xff; PC=0xaffe
PC=0xabcd; (0xabcd)==0x40; A==0xff; X==0xff; Y==0xff; (0x1fd)==0x55,0xfe,0xaf; S=0xfc > 6 P=0x55; S=0xff; PC=0xaffe

# RTS
PC=0xabcd; (0xabcd)==0x60; (0x1fe)==0xfe,0xaf; S=0xfd > 6 S=0xff; PC=0xafff
PC=0xabcd; (0xabcd)==0x60; (0x1fe)==0xfe,0xaf; S=0xfd;  A==0xff; X==0xff; Y==0xff; P==0xff > 6 S=0xff; PC=0xafff

#################### Transfer group ##############################
# TAX
PC=0; (0)==0xaa; A==0xff > 2 P=0x80; X=0xff; PC=1
PC=0; (0)==0xaa; A==19; X=0xff; Y==0xff; S==0xff; P=0xff > 2 P=0x7d; X=19; PC=1

# TAY
PC=0; (0)==0xa8; A==0xff > 2 P=0x80; Y=0xff; PC=1
PC=0; (0)==0xa8; A==19; Y=0xff; X==0xff; S==0xff; P=0xff > 2 P=0x7d; Y=19; PC=1

# TSX
PC=0; (0)==0xba; S==0xff > 2 P=0x80; X=0xff; PC=1
PC=0; (0)==0xba; S==19; Y==0xff; X=0xff; A==0xff; P=0xff > 2 P=0x7d; X=19; PC=1

# TXA
PC=0; (0)==0x8a; X==29; A=77; Y==89; S==34; P=0xff > 2 A=29; P=0x7d; PC=1

# TYA
PC=0; (0)==0x98; X==29; A=77; Y==89; S==34; P=0xff > 2 A=89; P=0x7d; PC=1

# TXS
PC=0; (0)==0x9a; X==29; A==77; Y==89; S=34; P==0xff > 2 S=29; PC=1
PC=0; (0)==0x9a; X==29; A==77; Y==89; S=34; P==0 > 2 S=29; PC=1



