;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; CP/M 2.2 BIOS for BIOSEmulator in Java
;
; Franz-Josef Elmer, November 2000
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MSIZE   EQU     61     ;CP/M Memory Size in K-byte
BIAS    EQU     (MSIZE-23)*1024
CCP     EQU     3400H+BIAS
BDOS    EQU     CCP+800H
BIOS    EQU     CCP+1600H

JMPCMD  EQU     0C3H


        ORG     BIOS
        JMP     BOOT
        JMP     WBOOT
        JMP     CONST
        JMP     CONIN
        JMP     CONOUT
        JMP     LIST
        JMP     PUNCH
        JMP     READER
        JMP     HOME
        JMP     SELDSK
        JMP     SETTRK
        JMP     SETSEC
        JMP     SETDMA
        JMP     READ
        JMP     WRITE
        JMP     LISTST
        JMP     SECTRAN
;
CONST:  MVI     A,2
        JMP     BIOSAD
CONIN:  MVI     A,3
        JMP     BIOSAD
CONOUT: MVI     A,4
        JMP     BIOSAD
LIST:   MVI     A,5
        JMP     BIOSAD
PUNCH:  MVI     A,6
        JMP     BIOSAD
READER: MVI     A,7
        JMP     BIOSAD
HOME:   MVI     A,8
        JMP     BIOSAD
SELDSK: MVI     A,9
        JMP     BIOSAD
SETTRK: MVI     A,10
        JMP     BIOSAD
SETSEC: MVI     A,11
        JMP     BIOSAD
SETDMA: MVI     A,12
        JMP     BIOSAD
READ:   MVI     A,13
        JMP     BIOSAD
WRITE:  MVI     A,14
        JMP     BIOSAD
LISTST: MVI     A,15
        JMP     BIOSAD
SECTRAN:MVI     A,16
        JMP     BIOSAD

BOOT:   LXI     H,CCP
        PUSH    H
BOOT1:  LDA     PORT
        LXI     H,BIOSAD1+1
        MOV     M,A
        LXI     H,BIOSAD2+1
        MOV     M,A
        MVI     A,JMPCMD
        STA     0
        LXI     H,BIOS+3
        SHLD    1
        STA     5
        LXI     H,BDOS+6
        SHLD    6
        LXI     H,4
        MOV     C,M
        RET

WBOOT:  LXI     SP,80H
        LXI     H,CCP+3
        PUSH    H
        LXI     H,BOOT1
        PUSH    H
        MVI     A,1
;       JMP     BIOSAD
;
;BIOSAD:BIOS to Java adapter
;
BIOSAD: MOV     L,C
        MOV     H,B
        SHLD    ARG1
        XCHG
        SHLD    ARG2
;        POP     H
;        LXI     D,-BIOS
;        DAD     D
;        MOV     A,L
BIOSAD1:OUT     0
BIOSAD2:IN      0
        LHLD    RESULT2
        RET

PHSSIZE EQU     2       ; log2(physical sector size / 128)
;DPH0:   DW      SECTRNS,0,0,0,DBUFFER,DISKPR0,CHCKTB0,ALLCTB0
;DPH1:   DW      SECTRNS,0,0,0,DBUFFER,DISKPR1,CHCKTB1,ALLCTB1
;DPH2:   DW      SECTRN2,0,0,0,DBUFFER,DISKPR2,CHCKTB2,ALLCTB2
DPH0:   DW      0,0,0,0,DBUFFER,DISKPR0,CHCKTB0,ALLCTB0
DPH1:   DW      1,0,0,0,DBUFFER,DISKPR1,CHCKTB1,ALLCTB1
DPH2:   DW      2,0,0,0,DBUFFER,DISKPR2,CHCKTB2,ALLCTB2
SECTRNS:DB      1,3,5,7,9,2,4,6,8,10
SECTRN2:DB      1,2,3,4,5,6,7,8,9,10
DISKPR0:DW      40
        DB      4,15,1
        DW      194,63
        DB      80H,0
        DW      16,2
DISKPR1:DW      40
        DB      4,15,1
        DW      194,63
        DB      80H,0
        DW      16,2
DISKPR2:DW      40
        DB      4,15,1
        DW      194,63
        DB      80H,0
        DW      0,0
DBUFFER:DS      128
CHCKTB0:DS      64
ALLCTB0:DS      72
CHCKTB1:DS      64
ALLCTB1:DS      72
CHCKTB2:DS      64
ALLCTB2:DS      72

; JBIOS System data. Will be used by the CPMEmulator class
PORT:   DS      1       ; port # for communication with Java part
ARG1:   DS      2       ; first BIOS argument (i.e. BC)
ARG2:   DS      2       ; second BIOS argument (i.e. DE)
RESULT2:DS      2       ; word result for HL
START:  DW      BIOS    ; start address
        DB      3       ; number of disks
DISK0:  DB      0
        DW      DPH0
DISK1:  DB      1
        DW      DPH1
DISK2:  DB      2
        DW      DPH2

; Location of JBIOS System data
        ORG     0FFFEH
        DW      PORT

        END     BIOS

