package jfrace;

import jfrace.cpu.MockCPU;
import jfrace.device.MockDevice;

import junit.framework.*;

public class AddressSpaceEventTest extends TestCase {
    private AddressSpace as;
    private CPU cpu;
    private Device device;

    public AddressSpaceEventTest(String name) {
        super(name);
    }

    protected void setUp() {
        as = new AddressSpace();
        cpu = new MockCPU();
        device = new MockDevice(10);
    }

    public void testConstructor() {
        test(as, AddressSpaceEvent.ADD, 1234, 0, cpu);
        test(as, AddressSpaceEvent.REMOVE, 11234, 234, cpu);
        test(as, AddressSpaceEvent.ADD, 234, 1, device);
        test(as, AddressSpaceEvent.REMOVE, 511234, 13, device);
    }

    /** Create an instance of <code>AddressSpaceEvent</code> an test it. */
    private void test(AddressSpace as, int type, int offset, int mask,
                      Hardware hardware) {
        AddressSpaceEvent ase = new AddressSpaceEvent(as, type, offset,
                                                      mask, hardware);

        assertEquals("Is address space the same", true,
                     ase.getAddressSpace() == as);
        assertEquals("Type", type, ase.getType());
        assertEquals("Offset", offset, ase.getAddressOffset());
        assertEquals("ModeMask", mask, ase.getModeMask());
    }

    public static Test suite() {
        /*
        TestSuite suite= new TestSuite();
        suite.addTest(new AddressSpaceEventTest("testConstructor"));
        return suite;
        */
        return new TestSuite(AddressSpaceEventTest.class);
    }
}
