package jfrace;

import junit.framework.*;

public class RegisterTest extends TestCase {
    public RegisterTest(String name) {
        super(name);
    }

    public static Test suite() {
        return new TestSuite(RegisterTest.class);
    }

    public void test() {
        test(8, Register.PROGRAM_COUNTER, "PC", 1234);
        test(18, Register.ADDRESS_REGISTER, "adr", 771234);
        test(-3, Register.DATA_REGISTER, "a", 713);
    }

    /** Create an instance of <code>Register</code> an test it. */
    private void test(int numberOfBits, int type, String name, int value) {
        Register r = new Register(numberOfBits, type, name, value);

        assertEquals("getName()", r.getName(), name);
        assertEquals("getType()", r.getType(), type);
        assertEquals("getNumberOfBits()", r.getNumberOfBits(), numberOfBits);
        assertEquals("getValue()", r.getValue(), value);
    }
}
