package jfrace.cpu;

import jfrace.*;

public class MockCPU2 implements CPU, AddressSpaceListener {
    public AddressSpace as;
    public int nextValue = 10;
    private int f1 = 0;
    private int f = 1;
    public String methodA;
    public String methodB;
    public String methodC;
    public String methodD;
    public int bNumber;
    public String cString;
    public int dNumber;
    public String dString;
    public int numberOfReceivedEvents;

    public void a() {
        methodA = "method a called.";
    }

    public void b(int aNumber) {
        methodB = "method b called.";
        bNumber = aNumber;
    }

    public void c(String aString) {
        methodC = "method c called.";
        cString = aString;
    }

    public void d(int aNumber, String aString) {
        methodD = "method d called.";
        dNumber = aNumber;
        dString = aString;
    }

    public String getName() {
        return "Test CPU";
    }

    public int getNumberOfBits() {
        return 8;
    }

    public int getNumberOfRegisters() {
        return 1;
    }

    public Register getRegister(int index) {
        return getProgramCounter();
    }

    public Register getProgramCounter() {
        return new Register(8, Register.PROGRAM_COUNTER, "PC", 199);
    }

    public void setRegisterValue(int index, int value) {}

    public void setAddressSpace(AddressSpace addressSpace) {
        as = addressSpace;
    }

    public AddressSpace getAddressSpace() {
        return as;
    }

    public void reset() {}

    public void interrupt(long interrupt) {}

    public String getErrorDescription() {
        return null;
    }

    public int next() {
        int nextF = f + f1;
        f1 = f;
        f = nextF;
        return nextValue--;
    }

    public boolean supportsDisassembling() {
        return false;
    }

    public int disassemble(StringBuffer sb, int address) {
        return -1;
    }

    public String toString() {
        return "Fibonacci " + f;
    }

    public void hardwareMoved(AddressSpaceEvent event) {
        numberOfReceivedEvents++;
    }
}
