package jfrace.device;

import jfrace.Device;

public class MockDevice implements Device {
    private int[] memory;

    public MockDevice(int size) {
        memory = new int[size];
    }

    public void reset() {}

    public int getNumberOfBits() {
        return 8;
    }

    public int getNumberOfUnits() {
        return memory.length;
    }

    public int getValue(int address) {
        return memory[address];
    }

    public void setValue(int address, int value) {
        memory[address] = value;
    }

    public byte getByte(int address) {
        return (byte) memory[address];
    }

    public void setByte(int address, byte value) {
        memory[address] = (int) value;
    }
}
